package pposRequest

import (
	"errors"
	"net/url"
)

func (that *PPOSClient) NewGetClassInfoRequest() *GetClassInfoRequest {
	return &GetClassInfoRequest{
		Request: Request{
			Client:     that,
			apiAddress: "/class/record/getClassInfo",
			publicParamsSlice: []string{
				"trade_no",
			},
		}}
}

type GetClassInfoRequest struct {
	Request
}

func (that *GetClassInfoRequest) SetTradeNo(value string) *GetClassInfoRequest {
	that.initParams()
	that.params.Set("trade_no", value) //信息获取通过trade_no
	return that
}

func (that *GetClassInfoRequest) SetOrderNo(value string) *GetClassInfoRequest {
	that.initParams()
	that.params.Set("order_no", value)
	return that
}

//Params ...
func (that *GetClassInfoRequest) Params() (url.Values, error) {
	that.initParams()
	_params := that.params
	if that.publicParamsSlice != nil {
		for _, _v := range that.publicParamsSlice {
			if _params.Get(_v) == "" {
				return nil, errors.New(that.apiAddress + "缺少参数:" + _v)
			}
		}
	}
	return _params, nil

}

//Do ...
func (that *GetClassInfoRequest) Do() (*GetClassInfoResponse, error) {
	_data, _err := that.Client.GetData(that.apiAddress, that)
	if _err != nil {
		return nil, _err
	}
	_result, _ok := _data.(map[string]interface{})
	if !_ok {
		return nil, errors.New(that.apiAddress + "请求响应格式不正确,错误代码01")
	}
	_list := new(GetClassInfoResponse)
	if _err := that.ParseResponeMp(_list, _result, false); _err != nil {
		return nil, errors.New(that.apiAddress + "请求响应格式化异常:" + _err.Error())
	}
	//返回结果
	return _list, nil
}
